## nmrpflash 0.9.14-16

=== Makefile ===
CC ?= gcc
PREFIX ?= /usr/local
VERSION = $(shell git describe --always | tail -c +2)
LIBS = -lpcap
CFLAGS += -Wall -g -DNMRPFLASH_VERSION=\"$(VERSION)\"
LDFLAGS += $(LIBS)

ifeq ($(shell uname -s),Linux)
	CFLAGS += $(shell pkg-config libnl-route-3.0 --cflags)
	LIBS += $(shell pkg-config libnl-route-3.0 --libs)
endif

nmrpflash_OBJ = nmrp.o tftp.o ethsock.o main.o util.o

.PHONY: clean install release release/macos release/linux release/win32

nmrpflash: $(nmrpflash_OBJ)
	$(CC) $(CFLAGS) -o nmrpflash $(nmrpflash_OBJ) $(LDFLAGS)

tftptest:
	CFLAGS=-DNMRPFLASH_TFTP_TEST make clean nmrpflash

%.o: %.c nmrpd.h
	$(CC) -c $(CFLAGS) $< -o $@

fuzz: clean
	CC=afl-gcc CFLAGS=-DNMRPFLASH_FUZZ make nmrpflash
	mv nmrpflash fuzz

dofuzz: fuzz
	echo core | sudo tee /proc/sys/kernel/core_pattern
	echo performance | sudo tee /sys/devices/system/cpu/cpu*/cpufreq/scaling_governor
	afl-fuzz -i fuzzin -o fuzzout -- ./fuzz
	echo powersave | sudo tee /sys/devices/system/cpu/cpu*/cpufreq/scaling_governor
clean:
	rm -f $(nmrpflash_OBJ) nmrpflash

install: nmrpflash
	install -m 755 nmrpflash $(PREFIX)/bin

release/macos:
	CFLAGS="-mmacosx-version-min=10.6" make release
	zip nmrpflash-$(VERSION)-macos.zip nmrpflash

release/linux: release
	zip nmrpflash-$(VERSION)-linux.zip nmrpflash

release/win32:
	zip nmrpflash-$(VERSION)-win32.zip nmrpflash.exe

release: clean nmrpflash
	strip nmrpflash

## nmrpflash 0.9.14-16-ge95526d

=== debian/changelog ===
nmrpflash (0.9.14-16-ge95526d-4) unstable; urgency=medium

  * changelog: correct typo in Helmut's name

 -- Damyan Ivanov <dmn@debian.org>  Sun, 10 May 2020 10:19:58 +0000

nmrpflash (0.9.14-16-ge95526d-3) unstable; urgency=medium

  * add patch from Helmut Grohne helping cross-building (Closes: #960165)

 -- Damyan Ivanov <dmn@debian.org>  Sun, 10 May 2020 07:43:27 +0000

nmrpflash (0.9.14-16-ge95526d-2) unstable; urgency=medium

  * use UTC date when passing date to pod2man, making the build reproducible.
    Thanks to Chris Lamb. (Closes: #958381)

 -- Damyan Ivanov <dmn@debian.org>  Tue, 21 Apr 2020 14:38:57 +0000

nmrpflash (0.9.14-16-ge95526d-1) unstable; urgency=medium

  * Initial release (Closes: #956867 -- ITP)

 -- Damyan Ivanov <dmn@debian.org>  Sun, 19 Apr 2020 06:34:46 +0000

=== debian/control ===
Source: nmrpflash
Section: otherosfs
Priority: optional
Maintainer: Damyan Ivanov <dmn@debian.org>
Build-Depends: debhelper-compat (= 12),
 libnl-3-dev,
 libnl-route-3-dev,
 libpcap0.8-dev,
 pkg-config
Standards-Version: 4.5.0
Homepage: https://github.com/jclehner/nmrpflash
Vcs-Browser: https://salsa.debian.org/debian/nmrpflash
Vcs-Git: https://salsa.debian.org/debian/nmrpflash.git
Rules-Requires-Root: no

Package: nmrpflash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: firmware flash utility for Netgear devices
 nmrpflash uses Netgear's NMRP protocol
 (http://www.chubb.wattle.id.au/PeterChubb/nmrp.html) to flash a new firmware
 image to a compatible device. It has been successfully used on a Netgear
 EX2700, DNG3700v2, R6220, R7000, D7000, WNR3500, R6400 and R6800, but is
 likely to be compatible with many other Netgear devices.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DPKG_EXPORT_BUILDFAGS=true
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/vendor.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export STANDALONE_VERSION="$(DEB_VERSION) ($(DEB_VENDOR))"


%:
	dh $@

override_dh_auto_build:
	CFLAGS="$(CPPFLAGS) $(CFLAGS)" dh_auto_build

MANUALS=debian/nmrpflash.1

debian/nmrpflash.1: debian/nmrpflash.pod
	pod2man -c "nmrpflash documentation" \
	    --release "nmrpflash $(DEB_VERSION_UPSTREAM)" \
	    --date "$(shell date --utc --date=@$(SOURCE_DATE_EPOCH) +%Y-%m-%d)" \
	    $< > $@

override_dh_auto_install:: $(MANUALS)
	mkdir -p debian/$(DEB_SOURCE)/usr/bin
	$(MAKE) install PREFIX=debian/$(DEB_SOURCE)/usr

=== debian/watch ===
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%nmrpflash-$1.tar.gz%" \
   https://github.com/jclehner/nmrpflash/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## nmrpflash 0.9.26+ds.1

=== CMakeLists.txt ===
# Still WIP! Use the regular Makefile for now!

cmake_minimum_required(VERSION 3.6)
set(CMAKE_OSX_ARCHITECTURES "arm64;x86_64" CACHE STRING "" FORCE)

project(nmrpflash)

if (NOT DEFINED NMRPFLASH_VERSION)
	find_package(Git)

	if(GIT_FOUND)
			execute_process(
				COMMAND ${GIT_EXECUTABLE} describe --always
				WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
				OUTPUT_VARIABLE GIT_VERSION
				OUTPUT_STRIP_TRAILING_WHITESPACE
			)
			string(SUBSTRING ${GIT_VERSION} 1 -1 GIT_VERSION)
			string(REGEX REPLACE "-g.*$" "" GIT_VERSION_CMAKE ${GIT_VERSION})
			string(REPLACE "-" "." GIT_VERSION_CMAKE ${GIT_VERSION_CMAKE})
			project(${CMAKE_PROJECT_NAME} VERSION ${GIT_VERSION_CMAKE})
			set(NMRPFLASH_VERSION ${GIT_VERSION})

	else()
		message(FATAL_ERROR "Git not found, and no NMRPFLASH_VERSION defined")
	endif()
else()
	project(${CMAKE_PROJECT_NAME} VERSION ${NMRPFLASH_VERSION})
endif()

set(PROJECT_SOURCE_DIR ${CMAKE_SOURCE_DIR})
add_compile_definitions(NMRPFLASH_VERSION=\"${NMRPFLASH_VERSION}\")
add_compile_options(-Wall)

if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	target_link_libraries(nmrpflash -lpcap "-framework CoreFoundation -framework SystemConfiguration")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	#target_sources(nmrpflash PRIVATE nmrpflash.rc)
	add_compile_definitions(_WIN32_WINNT=0x0600 WIN32_LEAN_AND_MEAN __USE_MINGW_ANSI_STDIO)
	link_libraries(-lwpcap -lPacket -liphlpapi -lws2_32 -ladvapi32)

	include_directories(./Npcap/Include)
	if (CMAKE_SIZEOF_VOID_P EQUAL 8)
		link_directories(./Npcap/Lib/x64)
	else()
		link_directories(./Npcap/Lib)
	endif()
else()
	find_package(PkgConfig)
	pkg_check_modules(PCAP REQUIRED IMPORTED_TARGET libpcap)
	link_libraries(PkgConfig::PCAP)

	if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
		pkg_check_modules(NLROUTE REQUIRED IMPORTED_TARGET libnl-route-3.0)
		link_libraries(PkgConfig::NLROUTE)
	endif()
endif()

add_executable(nmrpflash main.c nmrp.c tftp.c util.c ethsock.c)
add_executable(t_tftp t_tftp.c nmrp.c tftp.c util.c ethsock.c)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	target_sources(nmrpflash PRIVATE nmrpflash.rc)
endif()

=== Makefile ===
CC = $(CROSS)gcc
STRIP = $(CROSS)strip
PKG_CONFIG ?= pkg-config
PREFIX ?= /usr/local
VERSION := $(shell if [ -d .git ] && which git 2>&1 > /dev/null; then git describe --always | tail -c +2; else echo $$STANDALONE_VERSION; fi)
CFLAGS += -Wall -g -DNMRPFLASH_VERSION=\"$(VERSION)\"
SUFFIX ?=
NPCAP_SDK = 1.15
ARCH := $(shell uname -m)
LINUXDEPLOY = ./linuxdeploy-$(ARCH).AppImage
TMP := $(shell mktemp -d)
APPDIR = $(TMP)/AppDir
AFL = afl-gcc
DOCKER_BUILD_NAME=nmrpflash
DOCKER_CONTAINER_NAME=$(DOCKER_BUILD_NAME)-container

nmrpflash_OBJ = nmrp.o tftp.o ethsock.o util.o

ifneq ($(or $(MINGW),$(filter $(shell uname -s),Windows_NT)),)
	SUFFIX = .exe
	CC = $(MINGW)gcc
	STRIP = $(MINGW)strip
	WINDRES = $(MINGW)windres
	CFLAGS += -DWIN32_LEAN_AND_MEAN
	CFLAGS += -D_WIN32_WINNT=0x0600
	CFLAGS += -D__USE_MINGW_ANSI_STDIO
	CFLAGS += -I./Npcap/Include

	CC_TARGET = $(shell $(CC) -v 2>&1 | grep Target)

	ifneq ($(findstring x86_64,$(CC_TARGET)),)
		LDFLAGS += -L./Npcap/Lib/x64
	else ifneq ($(findstring aarch64,$(CC_TARGET)),)
		LDFLAGS += -L./Npcap/Lib/ARM64
	else
		LDFLAGS += -L./Npcap/Lib
	endif

	LDFLAGS += -lwpcap
	LDFLAGS += -lPacket
	LDFLAGS += -liphlpapi
	LDFLAGS += -lws2_32
	LDFLAGS += -ladvapi32
	nmrpflash_OBJ += windres.o
else ifeq ($(shell uname -s),Linux)
	CFLAGS += $(shell $(PKG_CONFIG) libnl-route-3.0 --cflags)
	CFLAGS += $(shell $(PKG_CONFIG) libpcap --cflags)
	LDFLAGS += $(shell $(PKG_CONFIG) libnl-route-3.0 --libs)
	LDFLAGS += $(shell $(PKG_CONFIG) libpcap --libs)
	AFL = afl-gcc
else
	LDFLAGS += -lpcap
ifeq ($(shell uname -s),Darwin)
	AFL=afl-clang
	TARGETS ?= -arch x86_64 -arch arm64
	CFLAGS += $(TARGETS)
	LDFLAGS += -framework CoreFoundation -framework SystemConfiguration $(TARGETS)
endif
endif

.PHONY: clean install release release/macos release/linux release/win32

nmrpflash$(SUFFIX): main.o $(nmrpflash_OBJ)
	$(CC) $^ -o $@ $(LDFLAGS)

t_tftp$(SUFFIX): t_tftp.o $(nmrpflash_OBJ)
	$(CC) $^ -o $@ $(LDFLAGS)

%.o: %.c nmrpd.h
	$(CC) -c $(CFLAGS) $< -o $@

windres.o: nmrpflash.rc nmrpflash.manifest nmrpflash.ico
	$(WINDRES) $< -o $@

fuzz_nmrp: tftp.c util.c nmrp.c fuzz.c
	$(AFL) $(CFLAGS) -DNMRPFLASH_FUZZ $^ -o $@

fuzz_tftp: tftp.c util.c nmrp.c fuzz.c
	$(AFL) $(CFLAGS) -DNMRPFLASH_FUZZ -DNMRPFLASH_FUZZ_TFTP $^ -o $@

dofuzz_tftp: fuzz_tftp
	echo core | sudo tee /proc/sys/kernel/core_pattern
	echo performance | sudo tee /sys/devices/system/cpu/cpu*/cpufreq/scaling_governor
	afl-fuzz -i fuzzin/tftp -o fuzzout/tftp -- ./fuzz_tftp fuzzin/tftp.bin
	echo powersave | sudo tee /sys/devices/system/cpu/cpu*/cpufreq/scaling_governor

clean:
	rm -f $(nmrpflash_OBJ) main.o t_tftp.o windres.o nmrpflash*.AppImage nmrpflash nmrpflash.exe fuzz_nmrp fuzz_tftp

install: nmrpflash
	install -d $(PREFIX)/bin
	install -s -m 755 nmrpflash $(PREFIX)/bin/

uninstall:
	rm -f $(PREFIX)/bin/nmrpflash

$(LINUXDEPLOY):
	wget -q -O $@ https://github.com/linuxdeploy/linuxdeploy/releases/download/continuous/$(shell basename $@)
	chmod +x $@

nmrpflash-$(ARCH).AppImage: $(LINUXDEPLOY) release
	rm -rf $(APPDIR)
	mkdir -p $(APPDIR)
	$(LINUXDEPLOY) --appdir $(APPDIR) -e nmrpflash -i nmrpflash.svg -o appimage --create-desktop-file

release/macos: release
	zip nmrpflash-$(VERSION)-macos.zip nmrpflash

release/linux: release
	zip nmrpflash-$(VERSION)-linux.zip nmrpflash

release/linux-appimage: nmrpflash-$(ARCH).AppImage
	mv $< $(TMP)/nmrpflash
	cd $(TMP); zip release.zip nmrpflash
	mv $(TMP)/release.zip nmrpflash-$(VERSION)-linux-$(ARCH).zip

release/win32:
	zip -X nmrpflash-$(VERSION)-win32.zip nmrpflash.exe

release: clean nmrpflash$(SUFFIX)
	$(STRIP) nmrpflash$(SUFFIX)

nmrpflash.ico: nmrpflash.svg
	convert -background transparent -define icon:auto-resize=256,64,48,32,16 $< $@

build-release-with-docker:
	docker build --build-arg CACHEBUST=$(shell date +%s) --build-arg NPCAP_SDK=$(NPCAP_SDK) --progress=plain -t $(DOCKER_BUILD_NAME) .
	-docker rm $(DOCKER_CONTAINER_NAME) &> /dev/null
	docker create --name $(DOCKER_CONTAINER_NAME) nmrpflash
	docker cp $(DOCKER_CONTAINER_NAME):/usr/src/nmrpflash/nmrpflash-$(VERSION)-linux-$(ARCH).zip .
	docker cp $(DOCKER_CONTAINER_NAME):/usr/src/nmrpflash/nmrpflash-$(VERSION)-win32.zip .
	docker rm $(DOCKER_CONTAINER_NAME)

=== debian/changelog ===
nmrpflash (0.9.26+ds.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Damyan Ivanov ]
  * convert debian/watch to version 5
  * exclude binary files from upstream sources
  * add debian/gbp.conf
  * New upstream version 0.9.26+ds.1 (Closes: #1121602)
  * disable pristine-tar
    will use the tag2upload and git-archive generated original source tarball
  * drop all patches (merged upstream)
  * Declare conformance with Policy 4.7.2 (no changes needed)
  * Build-depend on pkgconf instead of pkg-config
  * expand long description with more supported devices

 -- Damyan Ivanov <dmn@debian.org>  Mon, 01 Dec 2025 20:34:04 +0000

=== debian/control ===
Source: nmrpflash
Section: otherosfs
Priority: optional
Maintainer: Damyan Ivanov <dmn@debian.org>
Build-Depends: debhelper-compat (= 13),
 libnl-3-dev,
 libnl-route-3-dev,
 libpcap0.8-dev,
 pkgconf
Standards-Version: 4.7.2
Homepage: https://github.com/jclehner/nmrpflash
Vcs-Browser: https://salsa.debian.org/debian/nmrpflash
Vcs-Git: https://salsa.debian.org/debian/nmrpflash.git
Rules-Requires-Root: no

Package: nmrpflash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: firmware flash utility for Netgear devices
 nmrpflash uses Netgear's NMRP protocol
 (http://www.chubb.wattle.id.au/PeterChubb/nmrp.html) to flash a new firmware
 image to a compatible device. It has been successfully tested with various
 models (D7000, DNG3700v2, EX2700, EX6100v2, EX6120, EX6150v2, EX8000, R6020,
 R6080, R6100, R6220, R6400, R7000, R7000P, R6800, R8000, R8000P, R8500,
 RAX40, RAX75, RBR40, RBS40, RBR50, RBR50v2, RBS50, SRR60, SRS60, WAX202,
 WNDR3800, WNDR4300, WNDR4500v3, WNDR4700, WNR3500), but is likely to be
 compatible with most other Netgear devices as well.

=== debian/watch ===
Version: 5

Source: https://github.com/jclehner/nmrpflash/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%nmrpflash-$1.tar.gz%
Dversionmangle: s/\+ds\.\d+$//
Repacksuffix: +ds.1
